#!/usr/bin/perl -w

# Copyright 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use 5.004;
use strict;
use FindBin;
use Math::PlanePath::AlternateTerdragon;

BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon ':all';
use MyPrintwrap ':all';


$Printwrap = 2;
printwrap("% generated by tools/$FindBin::Script\n");

my $level = 11;
my $path = Math::PlanePath::AlternateTerdragon->new;
my ($n_lo, $n_hi) = $path->level_to_n_range($level);
my ($x_hi,$y_hi) = $path->n_to_xy($n_hi);
my $ex = 2;
my $ey = 0;

my $points = [
              [0,0],
              [$ex,$ey],
             ];

foreach (1 .. $level) {
  ($points,$ex,$ey) = MyTerdragon::alternate_hull_expand($points,$ex,$ey);
  # print "  % count ",scalar(@$points),"\n";
}

my $x_offset = 0;
my $y_offset = 0;
my $rotate = 0;
my $type = '';
sub draw {
  printwrap("\\draw[$type] ");
  my $join = '';
  $Printwrap = 2;
  foreach my $p (@$points) {
    my ($x,$y) = @$p;
    if ($rotate) {
      ($x,$y) = xy_rotate_plus120($x,$y);
    }
    $x += $x_offset;
    $y += $y_offset;
    $x /= 100;
    $y /= 100;
    printwrap("$join($x,$y) node[my dot]\n");
    $join = '--';
  }
  printwrap("--cycle;\n");
}

draw();

($x_offset,$y_offset) = ($x_hi,$y_hi);
$rotate = 1;
draw();

($x_offset,$y_offset) = $path->n_to_xy(2*$n_hi);
$rotate = 0;
draw();

$x_hi /= 100; $y_hi /= 100;
print "  \\node (M1) at ($x_hi,$y_hi) [my dot];\n";

($n_lo, $n_hi) = $path->level_to_n_range($level+1);
($x_hi,$y_hi) = $path->n_to_xy($n_hi);
$x_hi /= 100; $y_hi /= 100;
print "  \\node (end) at ($x_hi,$y_hi) [my dot];\n";

print "  % end generated\n";
exit 0;
