#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use List::Util 'min';
use Math::BaseCnv;
use Math::BigInt;

use FindBin;
use lib $FindBin::Bin;
use MyTerdragon '@fAltBpred_state_table','@fAltBpred_state_names';
use MyFLAT;
$|=1;


print "% generated by tools/$FindBin::Script\n";
my $max_len = Math::BigInt->new(32);

{
  MyTerdragon::fBpred_hullstouch_init();
  MyFLAT::FLAT_print_gp_inline_table(MyTerdragon::fAltRpred_flat(),
                                     "fAltBpred_state_table");
  foreach my $f (MyTerdragon::fAltRpred_flat()) {
    my $name = $f->{'name'};
    $name =~ s/ /_/;
    MyFLAT::FLAT_print_gp_inline_accepting($f, "${name}_accepting");
  }
  foreach my $state (0 .. $#fAltBpred_state_table) {
    my $state1 = $state + 1;
    my $name = $fAltBpred_state_names[$state];
    $name =~ tr/-/_/;
    print "% GP-DEFINE  fAltBpred_$name = $state1;\n";
  }
}

print "% end generated\n";
exit 0;
