#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use FindBin;

BEGIN { unshift @INC, $FindBin::Bin }
use MyTerdragon 'turn';
use MyPrintwrap ':all';

$Printwrap = 8;

printwrap("% generated by tools/$FindBin::Script\n");

my $max_n = 29;
my $prev_t = 1;
foreach my $n (1 .. $max_n) {
  my $t = turn($n);
  my $join = ($prev_t == $t ? '' : " \\; ");
  printwrap($t==1 ? $join.'{+}'
            : $t==-1 ? $join.'{-}'
            : die);
  $prev_t = $t;
}
printwrap_newline();

print "% GP-Test  turn($max_n) == ",turn($max_n),"\n";
$max_n++;
print "% GP-Test  turn($max_n) == ",turn($max_n),"\n";
printwrap("    % end generated\n");
exit 0;
